competition_master/urls.py
from django.contrib import admin
from django.urls import path, include
# from home.views import landingpage
from django.conf.urls import url

urlpatterns = [
    path('', include('home.urls')),
    path('accounts/', include('accounts.urls', namespace="accounts")),
    path('games/', include('game.urls', namespace="games")),
    path('quiz/', include('quiz.urls', namespace="quiz")),
    # path('accounts/', include('django.contrib.auth.urls')),
    path('admin/', admin.site.urls),
    url(r'^oauth/', include('social_django.urls', namespace='social')),
]

game/urls.py
from django.urls import path
from .views import Games, GameDetailView

app_name = "games"

urlpatterns = [
    path('', Games.as_view(), name="games_list"),
    path('<str:slug>/', GameDetailView.as_view(), name="game_detail"),
]

home/urls.py
from django.urls import path
from .views import landingpage, dashboard

app_name = "home"

urlpatterns = [
    path('', landingpage, name="index"),
    path('dashboard/', dashboard, name="dashboard"),
    path('test/', landingpage, name="test"),
]

quiz/urls.py
from django.urls import path
from .views import Topic, QuizDetailView

app_name = "quiz"

urlpatterns = [
    path('', Topic.as_view(), name="topic_list"),
    path('<str:slug>/', QuizDetailView.as_view(), name="quiz_detail"),
]

quiz/models.py
from django.db import models
# from django.shortcuts import reverse
from django.contrib.auth.models import User


class Topic(models.Model):
    name = models.CharField(max_length=255, unique=True)
    slug = models.SlugField(allow_unicode=False, unique=True,
                            blank=True)  # , default=uuid.uuid1)

    # def get_absolute_url(self):
    #     return reverse('quiz:quiz_detail', kwargs={'slug': self.slug})

    def __str__(self):
        """
        Name of the Topic
        """
        return self.name

    # def save(self, *args, **kwargs):
    #     self.slug = slugify(self.name)
    #     super().save(*args, **kwargs)


class Quiz_Question(models.Model):
    topic = models.ForeignKey(
        Topic, on_delete=models.CASCADE, related_name='topic')
    question_text = models.CharField(max_length=1000, blank=False, default='')
    # question_text = models.ForeignKey('Quiz_Option', on_delete=models.CASCADE)

    def __str__(self):
        """
        Text of the question
        """
        return self.question_text

    def get_options(self):
        return Quiz_Option.objects.filter(
            question__pk=self.pk
        )

    question_related_options = property(get_options)


class Quiz_Option(models.Model):
    question = models.ForeignKey(Quiz_Question,
                                 on_delete=models.CASCADE,
                                 related_name='questions', blank=False,
                                 default='')
    question_option = models.CharField(max_length=300)
    correct_option = models.BooleanField(default=False)

    def __str__(self):
        """
        Text of the option
        """
        return self.question_option


class QuizLog(models.Model):
    user = models.ForeignKey(User, on_delete=models.DO_NOTHING)
    topic = models.ForeignKey(Topic, on_delete=models.DO_NOTHING)
    # question = models.ForeignKey(Quiz_Question, on_delete=models.DO_NOTHING)
    question_id = models.IntegerField(default=0)
    # option = models.ForeignKey(Quiz_Option, on_delete=models.DO_NOTHING)
    option_id = models.IntegerField(default=0)
    # submitted = models.BooleanField(default=False)

    def __str__(self):
        """
        Username of the competitor
        """
        return self.user.username


class QuizScore(models.Model):
    user = models.ForeignKey(User, on_delete=models.DO_NOTHING)
    topic = models.ForeignKey(Topic, on_delete=models.DO_NOTHING, default='')
    score = models.IntegerField(default=0)

    def __str__(self):
        """
        Username of the competitor
        """
        return self.user.username

quiz/forms.py
import itertools
from django import forms
from django.utils.text import slugify
from .models import Topic, Quiz_Option, QuizScore
from django.core.exceptions import ValidationError


class TopicForm(forms.ModelForm):
    class Meta:
        model = Topic
        fields = (
            'name',
        )

    # To avoid unique constraint error in slug
    # e.g .C Programming and C++ programming
    # generates this error while adding them
    def save(self):
        instance = super(TopicForm, self).save(commit=False)

        instance.slug = orig = slugify(instance.title)

        for x in itertools.count(1):
            if not Topic.objects.filter(slug=instance.slug).exists():
                break
            instance.slug = '%s-%d' % (orig, x)

        instance.save()

        return instance


class QuizOptionForm(forms.ModelForm):
    class Meta:
        model = Quiz_Option
        fields = '__all__'

    def clean(self):
        data = self.cleaned_data
        question_text = self.cleaned_data["question"]

        if Quiz_Option.objects.filter(question=question_text).\
                exclude(pk=self.instance.pk).count() >= 4:
            raise ValidationError("Maximum four options allowed per question!")

        if Quiz_Option.objects.filter(question=question_text,
                                      correct_option=True).\
            exclude(pk=self.instance.pk)\
                .count() > 1:
            raise ValidationError("Only one correct option allowed.\
                                  This question already has correct \
                                      option set")

        # print("---------------")
        # print(str(data["correct_option"]))
        # print(Quiz_Option.objects.filter(question=question_text,
        #                                  correct_option=False).count())

        if Quiz_Option.objects.filter(question=question_text,
                                      correct_option=False).\
                count() >= 3 and \
                data["correct_option"] is False:
            raise ValidationError("This question has no correct \
                                      option set. Please set atleast one \
                                          option as correct")
        return data


# class UpdateQuizScore(forms.ModelForm):
#     class Meta:
#         model = QuizScore
#         exclude = '__all__'

quiz/views.py
from django.shortcuts import redirect
from django.views import generic
from .models import (Topic as TopicModel, Quiz_Option,
                     Quiz_Question, QuizScore, QuizLog)
from django.contrib.auth.mixins import LoginRequiredMixin, UserPassesTestMixin
from django.http import JsonResponse
from django.db.models import Count, Max
import json
from django.db import transaction


class Topic(LoginRequiredMixin, UserPassesTestMixin, generic.ListView):
    model = TopicModel
    ordering = ["name"]

    def test_func(self):
        if self.request.user.is_superuser:
            return False
        elif self.request.user.is_anonymous:
            return False
        else:
            return True

    def dispatch(self, request, *args, **kwargs):
        user_test_result = self.get_test_func()()
        if not user_test_result:
            if self.request.user.is_superuser:
                return redirect('admin:index')
            else:
                return redirect('home:index')
            # return self.handle_no_permission()
        return super(UserPassesTestMixin, self).dispatch(request,
                                                         *args, **kwargs)


class QuizDetailView(LoginRequiredMixin, UserPassesTestMixin,
                     generic.DetailView):
    model = Quiz_Question
    template_name = "quiz/quiz_detail.html"

    # slug_url_kwarg = "not_slug"
    slug_field = "topic__slug"

    def test_func(self):
        if self.request.user.is_superuser:
            return False
        elif self.request.user.is_anonymous:
            return False
        else:
            return True

    def dispatch(self, request, *args, **kwargs):
        user_test_result = self.get_test_func()()
        if not user_test_result:
            if self.request.user.is_superuser:
                return redirect('admin:index')
            else:
                return redirect('home:index')
            # return self.handle_no_permission()
        return super(UserPassesTestMixin, self).dispatch(request,
                                                         *args, **kwargs)

    def get_object(self):
        topic_id = TopicModel.objects.filter(
            slug=self.kwargs['slug']).values_list('id', flat=True)

        question_ids = Quiz_Question.objects.filter(
            topic__in=topic_id).values_list('id', flat=True)

        invalid_options_count = Quiz_Option.objects.values("question__id").\
            annotate(option_count=Count('question__id')).\
            filter(option_count__lt=4)

        ignore_questions = []

        for item in invalid_options_count:
            ignore_questions.append(item["question__id"])

        return Quiz_Question.objects.values("id", "question_text",
                                            "topic__name", "topic__slug").\
            filter(id__in=list(question_ids)).\
            exclude(id__in=ignore_questions)

    def get_context_data(self, **kwargs):
        # print(self.kwargs['slug'])

        # Selected topic questions
        context = super().get_context_data(**kwargs)

        topic_name = self.kwargs['slug']
        topic_obj = TopicModel.objects.get(slug=topic_name)

        optionQuery = self.get_custom_data(topic_name)

        question_option_dict = {}
        correct_question_option = {}
        valid_questions = []

        for option in optionQuery:
            if option["question_id"] in question_option_dict:
                question_option_dict[option["question_id"]].append(
                    option)
            else:
                valid_questions.append(option["question_id"])
                question_option_dict[option["question_id"]] = []
                question_option_dict[option["question_id"]].append(option)

            if option["correct_option"]:
                correct_question_option[option["question_id"]] = option["id"]

        context["question_option_dict"] = question_option_dict
        # Logic to get scores
        quizScoreQuery = QuizScore.objects.filter(topic=topic_obj,)

        if len(quizScoreQuery) == 0:
            context["best_score"] = 0
            context["highest_score"] = 0
            context["highest_scorer"] = ""
        else:
            quizUserScoreQuery = QuizScore.objects.\
                filter(topic=topic_obj, user=self.request.user)
            user_score_query = quizUserScoreQuery.aggregate(Max('score'))
            if user_score_query['score__max'] is None:
                user_score = 0
            else:
                user_score = user_score_query['score__max']

            highest_score_query = QuizScore.objects.all().\
                order_by('-score')[:1]
            # highest_score_query = QuizScore.objects.aggregate(Max('score'))

            if highest_score_query is None:
                highest_score = 0
            else:
                highest_score = highest_score_query[0].score
                # highest_score = highest_score_query['score__max']

            context["best_score"] = user_score
            context["highest_score"] = highest_score

            if highest_score_query[0].user == self.request.user:
                context["highest_scorer"] = "You"
            else:
                context["highest_scorer"] = highest_score_query[0].\
                    user.username

        return context

    def get_custom_data(self, topic_name):
        topic_id = TopicModel.objects.filter(
            slug=topic_name).values_list('id', flat=True)
        question_ids = Quiz_Question.objects.filter(
            topic__in=topic_id).values_list('id', flat=True)

        invalid_options_count = Quiz_Option.objects.values("question__id").\
            annotate(option_count=Count('question__id')).\
            filter(option_count__lt=4)

        ignore_questions = []

        for item in invalid_options_count:
            ignore_questions.append(item["question__id"])

        optionQuery = Quiz_Option.objects.\
            filter(question_id__in=list(question_ids)).\
            exclude(question_id__in=ignore_questions).\
            values("id", "question_id", "question_option", "correct_option")

        return optionQuery

    def post(self, request, **kwargs):
        # print(request.POST)

        post_data = json.loads(request.POST.get('values'))
        topic = request.POST.get('topic')

        topic_obj = TopicModel.objects.get(slug=topic)

        optionQuery = self.get_custom_data(topic)

        correct_question_option = {}

        for option in optionQuery:
            if option["correct_option"]:
                correct_question_option[option["question_id"]] = option["id"]

        correct_count = 0
        for key, value in post_data.items():
            if int(key) in correct_question_option and \
                    correct_question_option[int(key)] == value:
                correct_count += 1

        score = int((correct_count/(len(post_data)))*100)

        # Save score
        quiz_score_entry = QuizScore(
            user=self.request.user, topic=topic_obj, score=score)
        quiz_score_entry.save()

        # Save log
        with transaction.atomic():
            for key, value in post_data.items():
                entry = QuizLog(user=self.request.user, topic=topic_obj,
                                question_id=key, option_id=value)
                entry.save()

        quizScoreQuery = QuizScore.objects.filter(topic=topic_obj,)

        if len(quizScoreQuery) == 0:
            best_score = score
            highest_score = score
        else:
            quizUserScoreQuery = QuizScore.objects.\
                filter(topic=topic_obj, user=self.request.user)
            user_score_query = quizUserScoreQuery.aggregate(Max('score'))
            if user_score_query['score__max'] is None:
                best_score = 0
            else:
                best_score = user_score_query['score__max']

            # highest_score_query = QuizScore.objects.aggregate(Max('score'))
            # if highest_score_query['score__max'] is None:
            #     highest_score = 0
            # else:
            #     highest_score = highest_score_query['score__max']
            highest_scorer = ""
            highest_score_query = QuizScore.objects.all().order_by('score')[:1]
            # highest_score_query = QuizScore.objects.aggregate(Max('score'))
            if highest_score_query is None:
                highest_score = 0
            else:
                highest_score = highest_score_query[0].score
                if highest_score_query[0].user == self.request.user:
                    highest_scorer = "You"
                else:
                    highest_scorer = highest_score_query[0].user.username

                # highest_score = highest_score_query['score__max']
        # return JsonResponse({"success": "success"})
        return JsonResponse({"success": "success",
                             "best_score": int(best_score),
                             "highest_score": int(highest_score),
                             "highest_scorer": highest_scorer,
                             })

quiz/templates/quiz/discarded_quiz_detail.html
{% extends "base.html"%}
{% load staticfiles %}

{% block css-content%}
<link href="{% static 'quiz/quiz_detail.css' %}" rel="stylesheet">
{% endblock %}

{% block content%}
{% load quiz_tags %}
<nav aria-label="breadcrumb">
    <ol class="breadcrumb">
        <li class="breadcrumb-item"><a href="{% url 'home:index' %}">Home</a></li>
        <li class="breadcrumb-item"><a href="{% url 'games:games_list' %}">Quiz</a></li>
        <li class="breadcrumb-item active" aria-current="page">{{ object.0.topic__name }}</li>
    </ol>
</nav>

<div class="container mt-3">
    <article class="media content-section">
        <div class="media-body">
            <h2 class="article-title">{{ object.0.topic__name }}</h2>
            <p class="article-content">
                <strong>Objective:</strong>&nbsp;
                Test you knowledge in {{ object.0.topic__name }}
            </p>
        </div>
    </article>
</div>
<div class="container">
    {% for q in object %}
        <h1>{{q.question_text}}</h1>
    {% endfor %}
</div>
{% endblock%}

quiz/templates/quiz/quiz_detail.html
{% extends "base.html"%}
{% load staticfiles %}

{% block css-content%}
<link href="{% static 'quiz/quiz_detail.css' %}" rel="stylesheet">
{% endblock %}

{% block content%}
<!-- {#% load quiz_tags %#} -->
<nav aria-label="breadcrumb" class="position-fixed">
    <ol class="breadcrumb">
        <li class="breadcrumb-item"><a href="{% url 'home:index' %}">Home</a></li>
        <li class="breadcrumb-item"><a href="{% url 'quiz:topic_list' %}">Topic</a></li>
        <li class="breadcrumb-item active" aria-current="page">{{ object.0.topic__name }}</li>
    </ol>
</nav>

<div class="container mt-3">
    <article class="media content-section">
        <div class="media-body mt-5">
            <h2 class="article-title">{{ object.0.topic__name }}</h2>
            <p class="article-content">
                <strong>Objective:</strong>&nbsp;
                Test your knowledge in {{ object.0.topic__name }}
            </p>
            <small class="text-danger">Please don't refresh, otherwise you'll loose your changes</small>
        </div>
        <div class="float-right mt-5">
            <button class="btn btn-danger mb-2 btnEndQuiz">End Quiz</button>
            <br />
            <strong>Your best score:</strong>
            <span id="spn_best_score">{{best_score}}</span>
            <br />
            <strong>Highest Topic Score:</strong>
            <span id="spn_highest_score">
                {{highest_score}}
                {% if highest_scorer|length > 0%}
                    (<strong>{{highest_scorer}}</strong>)
                {% endif %}
            </span>
            <br />
            <strong>Total Questions:</strong>
            <span>{{question_option_dict|length}}</span>
            <br />
            <strong>Attempted:</strong>
            <span id="spnAttempted"></span>
        </div>
    </article>
</div>
<div class="container mt-3">
    <input type="hidden" name="topic" id="topic" value="{{ object.0.topic__slug }}">
    {% for q in object %}
    <div class="divQuestionRow cnt_{{forloop.counter}} q_{{q.id}}">
        <div class="float-left">
            <h3>Q{{forloop.counter}}.</h3>
        </div>
        <div class="float-right ml-3">
            <h3>{{q.question_text}}</h3>
        </div>
    </div>
    <div class="answerRow mt-3 cnt_{{forloop.counter}} q_{{q.id}}">

        {% for key, values in question_option_dict.items %}
        {% if key == q.id %}
        {% for v in values %}
        {% if forloop.first %}
        <div class="newOptionRow">
            {% endif %}
            <div value="{{key}}" class="col-md-5 p-3 border border-dark rounded divRow divOptionValue a_{{v.id}}">
                <h5 class="optionValue mx-auto">{{v.question_option|safe}}</h5>
            </div>
            {% if forloop.counter == 2 %}
        </div>
        <div class="newOptionRow">
            {% endif %}
            {% endfor %}
        </div>
        {% endif %}
        {% endfor %}
    </div>
    {% endfor %}
    <input type="hidden" name="current_question" id="current_question" value="1">
    <input type="hidden" name="total_question" id="total_question" value="{{question_option_dict|length}}">
    <div class="row mt-3">
        <div class="divNavLink">
            <button type="button" class="btn btn-secondary btn_prev">Prev</button>
        </div>
        <div class="divNavLink">
            <button type="button" class="btn btn-dark btn_next">Next</button>
        </div>
    </div>
</div>
<script>
    $(document).ready(function () {
        $("#spnAttempted").html(0);
        cur_quest_number = $("#current_question").val();
        $(".divQuestionRow").not(".cnt_" + cur_quest_number).hide();
        $(".answerRow").not(".cnt_" + cur_quest_number).hide();

        if (cur_quest_number == 1) {
            $(".btn_prev").hide();
        }

        // Disable Right click on page
        $(this).bind("contextmenu", function(e) {
                e.preventDefault();
        });
    });

    $(document).keydown(function(evtobj) {    
        // Disable Control or Shift or Alt key press
        if (evtobj.altKey || evtobj.ctrlKey || evtobj.shiftKey){
            evtobj.preventDefault();
        }
    });

    // function createCookie(name, value, days) {
    //     var expires;
    //     if (days) {
    //         var date = new Date();
    //         date.setTime(date.getTime() + (days * 24 * 60 * 60 * 1000));
    //         expires = "; expires=" + date.toGMTString();
    //     }
    //     else {
    //         expires = "";
    //     }
    //     document.cookie = name + "=" + value + expires + "; path=/";
    // }


    function getCookie(c_name) {
        if (document.cookie.length > 0) {
            c_start = document.cookie.indexOf(c_name + "=");
            if (c_start != -1) {
                c_start = c_start + c_name.length + 1;
                c_end = document.cookie.indexOf(";", c_start);
                if (c_end == -1) c_end = document.cookie.length;
                return unescape(document.cookie.substring(c_start, c_end));
            }
        }
        return "";
    }

    gCookieDictObj = {};

    $(document).on("click", ".btnEndQuiz", function () {
        if (confirm("Sure you want to end your quiz?")){
            optionsMarked = {}
            total_questions = $("#total_question").val();
            var q_regExp = /q_[0-9]+/;
            var a_regExp = /a_[0-9]+/;
            for (var i = 1; i <= total_questions; i++) {
                var elem = $(".cnt_" + i)[1];
                if ($(elem).find(".bg_success").length == 1) {
                    // console.log("exists for index = "+i);
                    quest = parseInt($($(elem).find(".bg_success")[0]).attr("value"));
                    aClasses = $($(elem).find(".bg_success")[0]).attr("class");
                    a_matches = a_regExp.exec(aClasses);
                    answer = parseInt((a_matches[0]).replace('a_', ''));
                    // console.log(quest+" > "+answer);
                    optionsMarked[quest] = answer;
                } else {
                    qClasses = $($(".cnt_" + i)[1]).attr("class");
                    q_matches = q_regExp.exec(qClasses);
                    quest = parseInt((q_matches[0]).replace('q_', ''));
                    optionsMarked[quest] = 0;
                }
            }


            $.ajax({
                url: '/quiz/updateScore/',
                dataType: 'json',
                type: 'post',
                headers: { "X-CSRFToken": getCookie("csrftoken") },
                // contentType: 'application/x-www-form-urlencoded',
                data: { 'values': JSON.stringify(optionsMarked), "topic": $("#topic").val() },
                success: function (data, textStatus, jQxhr) {
                    // $('#response pre').html(data);
                    // console.log("AJAX Success");
                    console.log(data)
                    $("#spn_best_score").html((data)["best_score"])
                    $("#spn_highest_score").html((data)["highest_score"])
                    // console.log(textStatus);
                    // console.log(jQxhr);
                },
                error: function (jqXhr, textStatus, errorThrown) {
                    // console.log("AJAX Error");
                    console.log(jqXhr);
                    console.log(errorThrown);
                    console.log(textStatus);
                }
            });
        }
    });

    $(document).on("click", ".divOptionValue", function () {
        var qClasses = $(".divQuestionRow:visible").attr("class");

        var q_regExp = / q_([0-9]+)$/;
        if (qClasses.match(q_regExp)) {
            var q_matches = q_regExp.exec(qClasses);

            cookieTitle = $(".breadcrumb-item.active").text();

            var aClasses = $(this).attr("class");
            var a_regExp = / a_([0-9]+)$/;

            if (aClasses.match(a_regExp)) {
                var a_matches = a_regExp.exec(aClasses);
                if (cookieTitle != undefined && cookieTitle != null && cookieTitle != "" && cookieTitle != "undefined") {
                    cookieTitle = cookieTitle.toLowerCase();
                    q_sel = q_matches[1];
                    a_sel = a_matches[1];

                    if (JSON.stringify(gCookieDictObj) == JSON.stringify({})) {
                        gCookieDictObj[cookieTitle] = {};
                        gCookieDictObj[cookieTitle][q_sel] = parseInt(a_sel);
                    } else if (gCookieDictObj[cookieTitle] == undefined || gCookieDictObj[cookieTitle] == "") {
                        gCookieDictObj[cookieTitle] = {};
                        gCookieDictObj[cookieTitle][q_sel] = parseInt(a_sel);
                    } else if (gCookieDictObj[cookieTitle][q_sel] == undefined) {
                        gCookieDictObj[cookieTitle][q_sel] = parseInt(a_sel);
                    } else if (gCookieDictObj[cookieTitle][q_sel] != undefined) {
                        gCookieDictObj[cookieTitle][q_sel] = parseInt(a_sel);
                    }

                    $(".divOptionValue:visible").removeClass("bg_success");
                    $(this).addClass("bg_success");
                    // console.log(gCookieDictObj);

                    attempted_questions = parseInt($(".bg_success").length);
                    $("#spnAttempted").html(attempted_questions);

                }
            }
        }

    });

    $(document).on("click", ".btn_prev", function () {
        document.body.scrollTop = 0; // For Safari
        document.documentElement.scrollTop = 0; // For Chrome, Firefox, IE and Opera

        display_question_number = $("#current_question").val();
        display_question_number--;

        // $(".divQuestionRow").not(".cnt_"+display_question_number).hide();
        // $(".answerRow").not(".cnt_"+display_question_number).hide();
        $(".divQuestionRow").hide();
        $(".answerRow").hide();
        $(".cnt_" + display_question_number).show();

        if (display_question_number > 1) {
            $(".btn_prev").show();
        } else {
            $(".btn_prev").hide();
        }

        if (display_question_number < total_question) {
            $(".btn_next").show();
        }else{
            $(".btn_next").hide();
        }

        $("#current_question").val(display_question_number);
    });

    $(document).on("click", ".btn_next", function () {
        document.body.scrollTop = 0; // For Safari
        document.documentElement.scrollTop = 0; // For Chrome, Firefox, IE and Opera

        display_question_number = $("#current_question").val();
        display_question_number++;


        // $(".divQuestionRow").not(".cnt_"+display_question_number).hide();
        // $(".answerRow").not(".cnt_"+display_question_number).hide();
        $(".divQuestionRow").hide();
        $(".answerRow").hide();
        $(".cnt_" + display_question_number).show();
        $("#current_question").val(display_question_number);
        total_question = $("#total_question").val();
        $(".btn_prev").show();

        if (display_question_number < total_question) {
            $(".btn_next").show();
        }else{
            $(".btn_next").hide();
        }
    });
</script>
{% endblock%}

quiz/templates/quiz/topic_list.html
{% extends "base.html"%}
{% load staticfiles %}

{% block css-content%}
<link href="{% static 'quiz/topic.css' %}" rel="stylesheet">
<link href="http://fonts.googleapis.com/css?family=Reenie+Beanie:regular" rel="stylesheet" type="text/css">
{% endblock %}
{% block content%}
<nav aria-label="breadcrumb">
    <ol class="breadcrumb">
        <li class="breadcrumb-item"><a href="{% url 'home:index' %}">Home</a></li>
        <li class="breadcrumb-item active" aria-current="page">Quiz Topics</li>
    </ol>
</nav>
<div class="container">
    {% if object_list%}
    <ul>
        {% for topic in object_list %}
        <li>
            <a href="{% url 'quiz:quiz_detail' slug=topic.slug %}">
                <h2>{{topic.name}}</h2>
            </a>
        </li>
        {% endfor %}
    </ul>
    {% else %}
    Sorry, no topics for Quiz found.
    {% endif %}
</div>
{% endblock%}